Cgl 0.60.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Groups Pages
Public Member Functions | Static Public Member Functions | Private Attributes | Friends | List of all members
OsiXprSolverInterface Class Reference

XPRESS-MP Solver Interface. More...

`#include <OsiXprSolverInterface.hpp>`

Inheritance diagram for OsiXprSolverInterface:
[legend]
Collaboration diagram for OsiXprSolverInterface:
[legend]

## Public Member Functions
virtual void | setObjSense (double s)
| Set objective function sense (1 for min (default), -1 for max,) More...
virtual void | setColSolution (const double *colsol)
| Set the primal solution column values. More...
virtual void | setRowPrice (const double *rowprice)
| Set dual solution vector. More...
Solve methods
virtual void | initialSolve ()
| Solve initial LP relaxation. More...
virtual void | resolve ()
| Resolve an LP relaxation after problem modification. More...
virtual void | branchAndBound ()
| Invoke solver's built-in enumeration algorithm. More...
Parameter set/get methods
The set methods return true if the parameter was set to the given value, false otherwise. There can be various reasons for failure: the given parameter is not applicable for the solver (e.g., refactorization frequency for the volume algorithm), the parameter is not yet implemented for the solver or simply the value of the parameter is out of the range the solver accepts. If a parameter setting call returns false check the details of your solver. The get methods return true if the given parameter is applicable for the solver and is implemented. In this case the value of the parameter is returned in the second argument. Otherwise they return false.
bool | setIntParam (OsiIntParam key, int value)
| Set an integer parameter. More...
bool | setDblParam (OsiDblParam key, double value)
| Set a double parameter. More...
bool | setStrParam (OsiStrParam key, const std::string &value)
| Set a string parameter. More...
bool | getIntParam (OsiIntParam key, int &value) const
| Get an integer parameter. More...
bool | getDblParam (OsiDblParam key, double &value) const
| Get a double parameter. More...
bool | getStrParam (OsiStrParam key, std::string &value) const
| Get a string parameter. More...
void | setMipStart (bool value)
bool | getMipStart () const
Methods returning info on how the solution process terminated
virtual bool | isAbandoned () const
| Are there a numerical difficulties? More...
virtual bool | isProvenOptimal () const
| Is optimality proven? More...
virtual bool | isProvenPrimalInfeasible () const
| Is primal infeasiblity proven? More...
virtual bool | isProvenDualInfeasible () const
| Is dual infeasiblity proven? More...
virtual bool | isPrimalObjectiveLimitReached () const
| Is the given primal objective limit reached? More...
virtual bool | isDualObjectiveLimitReached () const
| Is the given dual objective limit reached? More...
virtual bool | isIterationLimitReached () const
| Iteration limit reached? More...
WarmStart related methods
CoinWarmStart * | getEmptyWarmStart () const
| Get empty warm start object. More...
virtual CoinWarmStart * | getWarmStart () const
| Get warmstarting information. More...
virtual bool | setWarmStart (const CoinWarmStart *warmstart)
| Set warmstarting information. More...
Hotstart related methods (primarily used in strong branching). <br>
The user can create a hotstart (a snapshot) of the optimization process then reoptimize over and over again always starting from there. NOTE: between hotstarted optimizations only bound changes are allowed.
virtual void | markHotStart ()
| Create a hotstart point of the optimization process. More...
virtual void | solveFromHotStart ()
| Optimize starting from the hotstart. More...
virtual void | unmarkHotStart ()
| Delete the snapshot. More...
Methods related to querying the input data
virtual int | getNumCols () const
| Get number of columns. More...
virtual int | getNumRows () const
| Get number of rows. More...
virtual int | getNumElements () const
| Get number of nonzero elements. More...
virtual const double * | getColLower () const
| Get pointer to array[getNumCols()] of column lower bounds. More...
virtual const double * | getColUpper () const
| Get pointer to array[getNumCols()] of column upper bounds. More...
virtual const char * | getRowSense () const
| Get pointer to array[getNumRows()] of row constraint senses. More...
virtual const double * | getRightHandSide () const
| Get pointer to array[getNumRows()] of rows right-hand sides. More...
virtual const double * | getRowRange () const
| Get pointer to array[getNumRows()] of row ranges. More...
virtual const double * | getRowLower () const
| Get pointer to array[getNumRows()] of row lower bounds. More...
virtual const double * | getRowUpper () const
| Get pointer to array[getNumRows()] of row upper bounds. More...
virtual const double * | getObjCoefficients () const
| Get pointer to array[getNumCols()] of objective function coefficients. More...
virtual double | getObjSense () const
| Get objective function sense (1 for min (default), -1 for max) More...
virtual bool | isContinuous (int colIndex) const
| Return true if variable is continuous. More...
virtual const CoinPackedMatrix * | getMatrixByRow () const
| Get pointer to row-wise copy of matrix. More...
virtual const CoinPackedMatrix * | getMatrixByCol () const
| Get pointer to column-wise copy of matrix. More...
virtual double | getInfinity () const
| Get solver's value for infinity. More...
Methods related to querying the solution
virtual const double * | getColSolution () const
| Get pointer to array[getNumCols()] of primal solution vector. More...
virtual const double * | getRowPrice () const
| Get pointer to array[getNumRows()] of dual prices. More...
virtual const double * | getReducedCost () const
| Get a pointer to array[getNumCols()] of reduced costs. More...
virtual const double * | getRowActivity () const
| Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector. More...
virtual double | getObjValue () const
| Get objective function value. More...
virtual int | getIterationCount () const
| Get how many iterations it took to solve the problem (whatever "iteration" mean to the solver. More...
virtual std::vector< double * > | getDualRays (int maxNumRays, bool fullRay=false) const
| Get as many dual rays as the solver can provide. More...
virtual std::vector< double * > | getPrimalRays (int maxNumRays) const
| Get as many primal rays as the solver can provide. More...
Changing bounds on variables and constraints
virtual void | setObjCoeff (int elementIndex, double elementValue)
| Set an objective function coefficient. More...
virtual void | setColLower (int elementIndex, double elementValue)
| Set a single column lower bound Use -COIN_DBL_MAX for -infinity. More...
virtual void | setColUpper (int elementIndex, double elementValue)
| Set a single column upper bound Use COIN_DBL_MAX for infinity. More...
virtual void | setColBounds (int elementIndex, double lower, double upper)
| Set a single column lower and upper bound The default implementation just invokes setColLower() and setColUpper() More...
virtual void | setColSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of columns simultaneously The default implementation just invokes setColLower() and setColUpper() over and over again. More...
virtual void | setRowLower (int elementIndex, double elementValue)
| Set a single row lower bound Use -COIN_DBL_MAX for -infinity. More...
virtual void | setRowUpper (int elementIndex, double elementValue)
| Set a single row upper bound Use COIN_DBL_MAX for infinity. More...
virtual void | setRowBounds (int elementIndex, double lower, double upper)
| Set a single row lower and upper bound The default implementation just invokes setRowLower() and setRowUpper() More...
virtual void | setRowType (int index, char sense, double rightHandSide, double range)
| Set the type of a single row More...
virtual void | setRowSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of rows simultaneously The default implementation just invokes setRowLower() and setRowUpper() over and over again. More...
virtual void | setRowSetTypes (const int *indexFirst, const int *indexLast, const char *senseList, const double *rhsList, const double *rangeList)
| Set the type of a number of rows simultaneously The default implementation just invokes setRowType() over and over again. More...
Integrality related changing methods
virtual void | setContinuous (int index)
| Set the index-th variable to be a continuous variable. More...
virtual void | setInteger (int index)
| Set the index-th variable to be an integer variable. More...
virtual void | setContinuous (const int *indices, int len)
| Set the variables listed in indices (which is of length len) to be continuous variables. More...
virtual void | setInteger (const int *indices, int len)
| Set the variables listed in indices (which is of length len) to be integer variables. More...
Methods to expand a problem.<br>
Note that if a column is added then by default it will correspond to a continuous variable.
virtual void | addCol (const CoinPackedVectorBase &vec, const double collb, const double colub, const double obj)
| Add a column (primal variable) to the problem. More...
virtual void | addCols (const int numcols, const CoinPackedVectorBase *const *cols, const double *collb, const double *colub, const double *obj)
| Add a set of columns (primal variables) to the problem. More...
virtual void | deleteCols (const int num, const int *colIndices)
| Remove a set of columns (primal variables) from the problem. More...
virtual void | addRow (const CoinPackedVectorBase &vec, const double rowlb, const double rowub)
| Add a row (constraint) to the problem. More...
virtual void | addRow (const CoinPackedVectorBase &vec, const char rowsen, const double rowrhs, const double rowrng)
| Add a row (constraint) to the problem. More...
virtual void | addRows (const int numrows, const CoinPackedVectorBase *const *rows, const double *rowlb, const double *rowub)
| Add a set of rows (constraints) to the problem. More...
virtual void | addRows (const int numrows, const CoinPackedVectorBase *const *rows, const char *rowsen, const double *rowrhs, const double *rowrng)
| Add a set of rows (constraints) to the problem. More...
virtual void | deleteRows (const int num, const int *rowIndices)
| Delete a set of rows (constraints) from the problem. More...
Methods to input a problem
virtual void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub)
| Load in an problem by copying the arguments (the constraints on the rows are given by lower and upper bounds). More...
virtual void | assignProblem (CoinPackedMatrix *&matrix, double *&collb, double *&colub, double *&obj, double *&rowlb, double *&rowub)
| Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by lower and upper bounds). More...
virtual void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const char *rowsen, const double *rowrhs, const double *rowrng)
| Load in an problem by copying the arguments (the constraints on the rows are given by sense/rhs/range triplets). More...
virtual void | assignProblem (CoinPackedMatrix *&matrix, double *&collb, double *&colub, double *&obj, char *&rowsen, double *&rowrhs, double *&rowrng)
| Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by sense/rhs/range triplets). More...
virtual void | loadProblem (const int numcols, const int numrows, const int *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub)
| Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps). More...
virtual void | loadProblem (const int numcols, const int numrows, const int *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const char *rowsen, const double *rowrhs, const double *rowrng)
| Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps). More...
virtual int | readMps (const char *filename, const char *extension="mps")
| Read an mps file from the given filename. More...
virtual void | writeMps (const char *filename, const char *extension="mps", double objSense=0.0) const
| Write the problem into an mps file of the given filename. More...
Message handling
void | passInMessageHandler (CoinMessageHandler *handler)
| Pass in a message handler It is the client's responsibility to destroy a message handler installed by this routine; it will not be destroyed when the solver interface is destroyed. More...
Constructors and destructors
| OsiXprSolverInterface (int newrows=50, int newnz=100)
| Default Constructor. More...
virtual OsiSolverInterface * | clone (bool copyData=true) const
| Clone. More...
| OsiXprSolverInterface (const OsiXprSolverInterface &)
| Copy constructor. More...
OsiXprSolverInterface & | operator= (const OsiXprSolverInterface &rhs)
| Assignment operator. More...
virtual | ~OsiXprSolverInterface ()
| Destructor. More...
Public Member Functions inherited from OsiSolverInterface
virtual bool | setHintParam (OsiHintParam key, bool yesNo=true, OsiHintStrength strength=OsiHintTry, void *=NULL)
| Set a hint parameter. More...
virtual bool | getHintParam (OsiHintParam key, bool &yesNo, OsiHintStrength &strength, void *&otherInformation) const
| Get a hint parameter (all information) More...
virtual bool | getHintParam (OsiHintParam key, bool &yesNo, OsiHintStrength &strength) const
| Get a hint parameter (sense and strength only) More...
virtual bool | getHintParam (OsiHintParam key, bool &yesNo) const
| Get a hint parameter (sense only) More...
void | copyParameters (OsiSolverInterface &rhs)
| Copy all parameters in this section from one solver to another. More...
double | getIntegerTolerance () const
| Return the integrality tolerance of the underlying solver. More...
virtual CoinWarmStart * | getPointerToWarmStart (bool &mustDelete)
| Get warm start information. More...
virtual int | getNumIntegers () const
| Get the number of integer variables. More...
virtual bool | isBinary (int colIndex) const
| Return true if the variable is binary. More...
virtual bool | isInteger (int colIndex) const
| Return true if the variable is integer. More...
virtual bool | isIntegerNonBinary (int colIndex) const
| Return true if the variable is general integer. More...
virtual bool | isFreeBinary (int colIndex) const
| Return true if the variable is binary and not fixed. More...
const char * | columnType (bool refresh=false) const
| Return an array[getNumCols()] of column types. More...
void | setColumnType (int iColumn, char type)
| Set column type. More...
virtual const char * | getColType (bool refresh=false) const
| Return an array[getNumCols()] of column types. More...
virtual CoinPackedMatrix * | getMutableMatrixByRow () const
| Get a pointer to a mutable row-wise copy of the matrix. More...
virtual CoinPackedMatrix * | getMutableMatrixByCol () const
| Get a pointer to a mutable column-wise copy of the matrix. More...
virtual const double * | getStrictColSolution ()
| Get a pointer to an array[getNumCols()] of primal variable values guaranteed to be between the column lower and upper bounds. More...
virtual OsiVectorInt | getFractionalIndices (const double etol=1.e-05) const
| Get vector of indices of primal variables which are integer variables but have fractional values in the current solution. More...
virtual void | setObjCoeffSet (const int *indexFirst, const int *indexLast, const double *coeffList)
| Set a set of objective function coefficients. More...
virtual void | setObjective (const double *array)
| Set the objective coefficients for all columns. More...
virtual void | setColLower (const double *array)
| Set the lower bounds for all columns. More...
virtual void | setColUpper (const double *array)
| Set the upper bounds for all columns. More...
virtual int | reducedCostFix (double gap, bool justInteger=true)
| Fix variables at bound based on reduced cost. More...
virtual std::string | dfltRowColName (char rc, int ndx, unsigned digits=7) const
| Generate a standard name of the form Rnnnnnnn or Cnnnnnnn. More...
virtual std::string | getObjName (unsigned maxLen=static_cast< unsigned >(std::string::npos)) const
| Return the name of the objective function. More...
virtual void | setObjName (std::string name)
| Set the name of the objective function. More...
virtual std::string | getRowName (int rowIndex, unsigned maxLen=static_cast< unsigned >(std::string::npos)) const
| Return the name of the row. More...
virtual const OsiNameVec & | getRowNames ()
| Return a pointer to a vector of row names. More...
virtual void | setRowName (int ndx, std::string name)
| Set a row name. More...
virtual void | setRowNames (OsiNameVec &srcNames, int srcStart, int len, int tgtStart)
| Set multiple row names. More...
virtual void | deleteRowNames (int tgtStart, int len)
| Delete len row names starting at index tgtStart. More...
virtual std::string | getColName (int colIndex, unsigned maxLen=static_cast< unsigned >(std::string::npos)) const
| Return the name of the column. More...
virtual const OsiNameVec & | getColNames ()
| Return a pointer to a vector of column names. More...
virtual void | setColName (int ndx, std::string name)
| Set a column name. More...
virtual void | setColNames (OsiNameVec &srcNames, int srcStart, int len, int tgtStart)
| Set multiple column names. More...
virtual void | deleteColNames (int tgtStart, int len)
| Delete len column names starting at index tgtStart. More...
void | setRowColNames (const CoinMpsIO &mps)
| Set row and column names from a CoinMpsIO object. More...
void | setRowColNames (CoinModel &mod)
| Set row and column names from a CoinModel object. More...
void | setRowColNames (CoinLpIO &mod)
| Set row and column names from a CoinLpIO object. More...
virtual void | addCol (const CoinPackedVectorBase &vec, const double collb, const double colub, const double obj, std::string name)
| Add a named column (primal variable) to the problem. More...
virtual void | addCol (int numberElements, const int *rows, const double *elements, const double collb, const double colub, const double obj)
| Add a column (primal variable) to the problem. More...
virtual void | addCol (int numberElements, const int *rows, const double *elements, const double collb, const double colub, const double obj, std::string name)
| Add a named column (primal variable) to the problem. More...
virtual void | addCols (const int numcols, const CoinBigIndex *columnStarts, const int *rows, const double *elements, const double *collb, const double *colub, const double *obj)
| Add a set of columns (primal variables) to the problem. More...
void | addCols (const CoinBuild &buildObject)
| Add columns using a CoinBuild object. More...
int | addCols (CoinModel &modelObject)
| Add columns from a model object. More...
virtual void | addRow (const CoinPackedVectorBase &vec, const double rowlb, const double rowub, std::string name)
| Add a named row (constraint) to the problem. More...
virtual void | addRow (const CoinPackedVectorBase &vec, const char rowsen, const double rowrhs, const double rowrng, std::string name)
| Add a named row (constraint) to the problem. More...
virtual void | addRow (int numberElements, const int *columns, const double *element, const double rowlb, const double rowub)
| Add a row (constraint) to the problem. More...
virtual void | addRows (const int numrows, const CoinBigIndex *rowStarts, const int *columns, const double *element, const double *rowlb, const double *rowub)
| Add a set of rows (constraints) to the problem. More...
void | addRows (const CoinBuild &buildObject)
| Add rows using a CoinBuild object. More...
int | addRows (CoinModel &modelObject)
| Add rows from a CoinModel object. More...
virtual void | replaceMatrixOptional (const CoinPackedMatrix &)
| Replace the constraint matrix. More...
virtual void | replaceMatrix (const CoinPackedMatrix &)
| Replace the constraint matrix. More...
virtual void | saveBaseModel ()
| Save a copy of the base model. More...
virtual void | restoreBaseModel (int numberRows)
| Reduce the constraint system to the specified number of constraints. More...
virtual ApplyCutsReturnCode | applyCuts (const OsiCuts &cs, double effectivenessLb=0.0)
| Apply a collection of cuts. More...
virtual void | applyRowCuts (int numberCuts, const OsiRowCut *cuts)
| Apply a collection of row cuts which are all effective. More...
virtual void | applyRowCuts (int numberCuts, const OsiRowCut **cuts)
| Apply a collection of row cuts which are all effective. More...
void | deleteBranchingInfo (int numberDeleted, const int *which)
| Deletes branching information before columns deleted. More...
virtual int | loadFromCoinModel (CoinModel &modelObject, bool keepSolution=false)
| Load a model from a CoinModel object. More...
virtual int | readMps (const char *filename, const char *extension, int &numberSets, CoinSet **&sets)
| Read a problem in MPS format from the given full filename. More...
virtual int | readGMPL (const char *filename, const char *dataname=NULL)
| Read a problem in GMPL format from the given filenames. More...
int | writeMpsNative (const char *filename, const char **rowNames, const char **columnNames, int formatType=0, int numberAcross=2, double objSense=0.0, int numberSOS=0, const CoinSet *setInfo=NULL) const
| Write the problem in MPS format to the specified file with more control over the output. More...
virtual void | writeLp (const char *filename, const char *extension="lp", double epsilon=1e-5, int numberAcross=10, int decimals=9, double objSense=0.0, bool useRowNames=true) const
| Write the problem into an Lp file of the given filename with the specified extension. More...
virtual void | writeLp (FILE *fp, double epsilon=1e-5, int numberAcross=10, int decimals=5, double objSense=0.0, bool useRowNames=true) const
| Write the problem into the file pointed to by the parameter fp. More...
int | writeLpNative (const char *filename, char const *const *const rowNames, char const *const *const columnNames, const double epsilon=1.0e-5, const int numberAcross=10, const int decimals=5, const double objSense=0.0, const bool useRowNames=true) const
| Write the problem into an Lp file. More...
int | writeLpNative (FILE *fp, char const *const *const rowNames, char const *const *const columnNames, const double epsilon=1.0e-5, const int numberAcross=10, const int decimals=5, const double objSense=0.0, const bool useRowNames=true) const
| Write the problem into the file pointed to by the parameter fp. More...
virtual int | readLp (const char *filename, const double epsilon=1e-5)
| Read file in LP format from file with name filename. More...
int | readLp (FILE *fp, const double epsilon=1e-5)
| Read file in LP format from the file pointed to by fp. More...
int | differentModel (OsiSolverInterface &other, bool ignoreNames=true)
| Check two models against each other. More...
void | statistics (double &minimumNegative, double &maximumNegative, double &minimumPositive, double &maximumPositive, int type=3) const
| Get some statistics about model - min/max always computed type 0->4 , larger gives more information 0 - Just set min and max values of coefficients. More...
void | setApplicationData (void *appData)
| Set application data. More...
void | setAuxiliaryInfo (OsiAuxInfo *auxiliaryInfo)
| Create a clone of an Auxiliary Information object. More...
void * | getApplicationData () const
| Get application data. More...
OsiAuxInfo * | getAuxiliaryInfo () const
| Get pointer to auxiliary info object. More...
void | newLanguage (CoinMessages::Language language)
| Set language. More...
void | setLanguage (CoinMessages::Language language)
CoinMessageHandler * | messageHandler () const
| Return a pointer to the current message handler. More...
CoinMessages | messages ()
| Return the current set of messages. More...
CoinMessages * | messagesPointer ()
| Return a pointer to the current set of messages. More...
bool | defaultHandler () const
| Return true if default handler. More...
void | findIntegers (bool justCount)
| Identify integer variables and create corresponding objects. More...
virtual int | findIntegersAndSOS (bool justCount)
| Identify integer variables and SOS and create corresponding objects. More...
int | numberObjects () const
| Get the number of objects. More...
void | setNumberObjects (int number)
| Set the number of objects. More...
OsiObject ** | objects () const
| Get the array of objects. More...
const OsiObject * | object (int which) const
| Get the specified object. More...
OsiObject * | modifiableObject (int which) const
| Get the specified object. More...
void | deleteObjects ()
| Delete all object information. More...
void | addObjects (int numberObjects, OsiObject **objects)
| Add in object information. More...
double | forceFeasible ()
| Use current solution to set bounds so current integer feasible solution will stay feasible. More...
virtual void | activateRowCutDebugger (const char *modelName)
| Activate the row cut debugger. More...
virtual void | activateRowCutDebugger (const double *solution, bool enforceOptimality=true)
| Activate the row cut debugger using a full solution array. More...
const OsiRowCutDebugger * | getRowCutDebugger () const
| Get the row cut debugger provided the solution known to the debugger is within the feasible region held in the solver. More...
OsiRowCutDebugger * | getRowCutDebuggerAlways () const
| Get the row cut debugger object. More...
virtual int | canDoSimplexInterface () const
| Return the simplex implementation level. More...
virtual void | enableFactorization () const
| Prepare the solver for the use of tableau access methods. More...
virtual void | disableFactorization () const
| Undo the effects of enableFactorization. More...
virtual bool | basisIsAvailable () const
| Check if an optimal basis is available. More...
bool | optimalBasisIsAvailable () const
| Synonym for basisIsAvailable. More...
virtual void | getBasisStatus (int *cstat, int *rstat) const
| Retrieve status information for column and row variables. More...
virtual int | setBasisStatus (const int *cstat, const int *rstat)
| Set the status of column and row variables and update the basis factorization and solution. More...
virtual void | getReducedGradient (double *columnReducedCosts, double *duals, const double *c) const
| Calculate duals and reduced costs for the given objective coefficients. More...
virtual void | getBInvARow (int row, double *z, double *slack=NULL) const
| Get a row of the tableau. More...
virtual void | getBInvRow (int row, double *z) const
| Get a row of the basis inverse. More...
virtual void | getBInvACol (int col, double *vec) const
| Get a column of the tableau. More...
virtual void | getBInvCol (int col, double *vec) const
| Get a column of the basis inverse. More...
virtual void | getBasics (int *index) const
| Get indices of basic variables. More...
virtual void | enableSimplexInterface (bool doingPrimal)
| Enables normal operation of subsequent functions. More...
virtual void | disableSimplexInterface ()
| Undo whatever setting changes the above method had to make. More...
virtual int | pivot (int colIn, int colOut, int outStatus)
| Perform a pivot by substituting a colIn for colOut in the basis. More...
virtual int | primalPivotResult (int colIn, int sign, int &colOut, int &outStatus, double &t, CoinPackedVector *dx)
| Obtain a result of the primal pivot Outputs: colOut – leaving column, outStatus – its status, t – step size, and, if dx!=NULL, *dx – primal ray direction. More...
virtual int | dualPivotResult (int &colIn, int &sign, int colOut, int outStatus, double &t, CoinPackedVector *dx)
| Obtain a result of the dual pivot (similar to the previous method) Differences: entering variable and a sign of its change are now the outputs, the leaving variable and its statuts – the inputs If dx!=NULL, then *dx contains dual ray Return code: same. More...
| OsiSolverInterface ()
| Default Constructor. More...
| OsiSolverInterface (const OsiSolverInterface &)
| Copy constructor. More...
OsiSolverInterface & | operator= (const OsiSolverInterface &rhs)
| Assignment operator. More...
virtual | ~OsiSolverInterface ()
| Destructor. More...
virtual void | reset ()
| Reset the solver interface. More...

## Static Public Member Functions
static int | version ()
| Return XPRESS-MP Version number. More...

## Protected Member Functions
Protected methods
virtual void | applyRowCut (const OsiRowCut &rc)
| Apply a row cut. Return true if cut was applied. More...
virtual void | applyColCut (const OsiColCut &cc)
| Apply a column cut (bound adjustment). More...
Protected Member Functions inherited from OsiSolverInterface
void | convertBoundToSense (const double lower, const double upper, char &sense, double &right, double &range) const
| A quick inlined function to convert from the lb/ub style of constraint definition to the sense/rhs/range style. More...
void | convertSenseToBound (const char sense, const double right, const double range, double &lower, double &upper) const
| A quick inlined function to convert from the sense/rhs/range style of constraint definition to the lb/ub style. More...
template<class T >
T | forceIntoRange (const T value, const T lower, const T upper) const
| A quick inlined function to force a value to be between a minimum and a maximum value. More...
void | setInitialData ()
| Set OsiSolverInterface object state for default constructor. More...

## Private Member Functions
Private methods
void | gutsOfCopy (const OsiXprSolverInterface &source)
| The real work of a copy constructor (used by copy and assignment) More...
void | gutsOfConstructor ()
| The real work of a constructor (used by construct and assignment) More...
void | gutsOfDestructor ()
| The real work of a destructor (used by copy and assignment) More...
void | freeSolution ()
| Destroy cached copy of solution data (whenever it changes) More...
void | freeCachedResults ()
| Destroy cached copies of problem and solution data (whenever they change) More...
int | getNumIntVars () const
| Number of integer variables in the problem. More...
Methods to support for XPRESS-MP multiple matrix facility
void | getVarTypes () const
| Build cached copy of variable types. More...
void | activateMe () const
| Save the current problem in XPRESS (if necessary) and make this problem current (restore if necessary). More...
bool | isDataLoaded () const
| Save and restore are necessary if there is data associated with this problem. More...

## Private Attributes
bool | domipstart
| Whether to pass a column solution to XPRESS before starting MIP solve (loadmipsol) More...
Data to support for XPRESS-MP multiple matrix facility
XPRSprob | prob_
std::string | xprProbname_
| XPRESS problem name (should be unique for each saved problem) More...
Cached copies of XPRESS-MP problem data
CoinPackedMatrix * | matrixByRow_
| Pointer to row-wise copy of problem matrix coefficients. More...
CoinPackedMatrix * | matrixByCol_
double * | colupper_
| Pointer to dense vector of structural variable upper bounds. More...
double * | collower_
| Pointer to dense vector of structural variable lower bounds. More...
double * | rowupper_
| Pointer to dense vector of slack variable upper bounds. More...
double * | rowlower_
| Pointer to dense vector of slack variable lower bounds. More...
char * | rowsense_
| Pointer to dense vector of row sense indicators. More...
double * | rhs_
| Pointer to dense vector of row right-hand side values. More...
double * | rowrange_
| Pointer to dense vector of slack upper bounds for range constraints (undefined for non-range rows) More...
double * | objcoeffs_
| Pointer to dense vector of objective coefficients. More...
double | objsense_
| Sense of objective (1 for min; -1 for max) More...
double * | colsol_
| Pointer to dense vector of primal structural variable values. More...
double * | rowsol_
| Pointer to dense vector of primal slack variable values. More...
double * | rowact_
| Pointer to dense vector of primal slack variable values. More...
double * | rowprice_
| Pointer to dense vector of dual row variable values. More...
double * | colprice_
| Pointer to dense vector of dual column variable values. More...
int * | ivarind_
| Pointer to list of indices of XPRESS "global" variables. More...
char * | ivartype_
| Pointer to list of global variable types: More...
char * | vartype_
| Pointer to dense vector of variable types (as above, or 'C' for continuous) More...
bool | lastsolvewasmip
| Indicates whether the last solve was for a MIP or an LP. More...

## Static Private Attributes
Private static class data
static const char * | logFileName_
| Name of the logfile. More...
static FILE * | logFilePtr_
| The FILE* to the logfile. More...
static unsigned int | numInstances_
| Number of live problem instances. More...
static unsigned int | osiSerial_
| Counts calls to incrementInstanceCounter() More...

## Friends
void | OsiXprSolverInterfaceUnitTest (const std::string &mpsDir, const std::string &netlibDir)
| A function that tests the methods in the OsiXprSolverInterface class. More...

## Static instance counter methods
XPRSprob | getLpPtr ()
| Return a pointer to the XPRESS problem. More...
static void | incrementInstanceCounter ()
| XPRESS has a context that must be created prior to all other XPRESS calls. More...
static void | decrementInstanceCounter ()
| XPRESS has a context that should be deleted after XPRESS calls. More...
static unsigned int | getNumInstances ()
| Return the number of instances of instantiated objects using XPRESS services. More...

## Log File
static int | iXprCallCount_
static FILE * | getLogFilePtr ()
| Get logfile FILE *. More...
static void | setLogFileName (const char *filename)
| Set logfile name. More...

## Additional Inherited Members
Public Types inherited from OsiSolverInterface
typedef std::vector< std::string > | OsiNameVec
| Data type for name vectors. More...
Protected Attributes inherited from OsiSolverInterface
OsiRowCutDebugger * | rowCutDebugger_
| Pointer to row cut debugger object. More...
CoinMessageHandler * | handler_
| Message handler. More...
bool | defaultHandler_
| Flag to say if the currrent handler is the default handler. More...
CoinMessages | messages_
| Messages. More...
int | numberIntegers_
| Number of integers. More...
int | numberObjects_
| Total number of objects. More...
OsiObject ** | object_
| Integer and ... information (integer info normally at beginning) More...
char * | columnType_
| Column type 0 - continuous 1 - binary (may get fixed later) 2 - general integer (may get fixed later) 3 - if supported - semi-continuous 4 - if supported - semi-continuous integer. More...

## Detailed Description

XPRESS-MP Solver Interface.

Instantiation of OsiSolverInterface for XPRESS-MP

Definition at line 21 of file OsiXprSolverInterface.hpp.

## Constructor & Destructor Documentation

OsiXprSolverInterface::OsiXprSolverInterface | ( | int | newrows = `50`,
|  | int | newnz = `100`
| ) |  |

Default Constructor.

OsiXprSolverInterface::OsiXprSolverInterface | ( | const OsiXprSolverInterface & |  | ) |

Copy constructor.

virtual OsiXprSolverInterface::~OsiXprSolverInterface | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

virtual void OsiXprSolverInterface::initialSolve | ( |  | ) |
| virtual

Solve initial LP relaxation.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::resolve | ( |  | ) |
| virtual

Resolve an LP relaxation after problem modification.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::branchAndBound | ( |  | ) |
| virtual

Invoke solver's built-in enumeration algorithm.

Implements OsiSolverInterface.

bool OsiXprSolverInterface::setIntParam | ( | OsiIntParam | key,
|  | int | value
| ) |  |
| virtual

Set an integer parameter.

Reimplemented from OsiSolverInterface.

bool OsiXprSolverInterface::setDblParam | ( | OsiDblParam | key,
|  | double | value
| ) |  |
| virtual

Set a double parameter.

Reimplemented from OsiSolverInterface.

bool OsiXprSolverInterface::setStrParam | ( | OsiStrParam | key,
|  | const std::string & | value
| ) |  |
| virtual

Set a string parameter.

Reimplemented from OsiSolverInterface.

bool OsiXprSolverInterface::getIntParam | ( | OsiIntParam | key,
|  | int & | value
| ) |  | const
| virtual

Get an integer parameter.

Reimplemented from OsiSolverInterface.

bool OsiXprSolverInterface::getDblParam | ( | OsiDblParam | key,
|  | double & | value
| ) |  | const
| virtual

Get a double parameter.

Reimplemented from OsiSolverInterface.

bool OsiXprSolverInterface::getStrParam | ( | OsiStrParam | key,
|  | std::string & | value
| ) |  | const
| virtual

Get a string parameter.

Reimplemented from OsiSolverInterface.

void OsiXprSolverInterface::setMipStart | ( | bool | value | ) |
| inline

Definition at line 65 of file OsiXprSolverInterface.hpp.

bool OsiXprSolverInterface::getMipStart | ( |  | ) | const
| inline

Definition at line 67 of file OsiXprSolverInterface.hpp.

virtual bool OsiXprSolverInterface::isAbandoned | ( |  | ) | const
| virtual

Are there a numerical difficulties?

Implements OsiSolverInterface.

virtual bool OsiXprSolverInterface::isProvenOptimal | ( |  | ) | const
| virtual

Is optimality proven?

Implements OsiSolverInterface.

virtual bool OsiXprSolverInterface::isProvenPrimalInfeasible | ( |  | ) | const
| virtual

Is primal infeasiblity proven?

Implements OsiSolverInterface.

virtual bool OsiXprSolverInterface::isProvenDualInfeasible | ( |  | ) | const
| virtual

Is dual infeasiblity proven?

Implements OsiSolverInterface.

virtual bool OsiXprSolverInterface::isPrimalObjectiveLimitReached | ( |  | ) | const
| virtual

Is the given primal objective limit reached?

Reimplemented from OsiSolverInterface.

virtual bool OsiXprSolverInterface::isDualObjectiveLimitReached | ( |  | ) | const
| virtual

Is the given dual objective limit reached?

Reimplemented from OsiSolverInterface.

virtual bool OsiXprSolverInterface::isIterationLimitReached | ( |  | ) | const
| virtual

Iteration limit reached?

Implements OsiSolverInterface.

CoinWarmStart* OsiXprSolverInterface::getEmptyWarmStart | ( |  | ) | const
| virtual

Get empty warm start object.

Implements OsiSolverInterface.

virtual CoinWarmStart* OsiXprSolverInterface::getWarmStart | ( |  | ) | const
| virtual

Get warmstarting information.

Implements OsiSolverInterface.

virtual bool OsiXprSolverInterface::setWarmStart | ( | const CoinWarmStart * | warmstart | ) |
| virtual

Set warmstarting information.

Return true/false depending on whether the warmstart information was accepted or not.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::markHotStart | ( |  | ) |
| virtual

Create a hotstart point of the optimization process.

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::solveFromHotStart | ( |  | ) |
| virtual

Optimize starting from the hotstart.

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::unmarkHotStart | ( |  | ) |
| virtual

Delete the snapshot.

Reimplemented from OsiSolverInterface.

virtual int OsiXprSolverInterface::getNumCols | ( |  | ) | const
| virtual

Get number of columns.

Implements OsiSolverInterface.

virtual int OsiXprSolverInterface::getNumRows | ( |  | ) | const
| virtual

Get number of rows.

Implements OsiSolverInterface.

virtual int OsiXprSolverInterface::getNumElements | ( |  | ) | const
| virtual

Get number of nonzero elements.

Implements OsiSolverInterface.

virtual const double* OsiXprSolverInterface::getColLower | ( |  | ) | const
| virtual

Get pointer to array[getNumCols()] of column lower bounds.

Implements OsiSolverInterface.

virtual const double* OsiXprSolverInterface::getColUpper | ( |  | ) | const
| virtual

Get pointer to array[getNumCols()] of column upper bounds.

Implements OsiSolverInterface.

virtual const char* OsiXprSolverInterface::getRowSense | ( |  | ) | const
| virtual

Get pointer to array[getNumRows()] of row constraint senses.

- 'L': <= constraint
- 'E': = constraint
- 'G': >= constraint
- 'R': ranged constraint
- 'N': free constraint

Implements OsiSolverInterface.

virtual const double* OsiXprSolverInterface::getRightHandSide | ( |  | ) | const
| virtual

Get pointer to array[getNumRows()] of rows right-hand sides.

- if rowsense()[i] == 'L' then rhs()[i] == rowupper()[i]
- if rowsense()[i] == 'G' then rhs()[i] == rowlower()[i]
- if rowsense()[i] == 'R' then rhs()[i] == rowupper()[i]
- if rowsense()[i] == 'N' then rhs()[i] == 0.0

Implements OsiSolverInterface.

virtual const double* OsiXprSolverInterface::getRowRange | ( |  | ) | const
| virtual

Get pointer to array[getNumRows()] of row ranges.

- if rowsense()[i] == 'R' then rowrange()[i] == rowupper()[i] - rowlower()[i]
- if rowsense()[i] != 'R' then rowrange()[i] is 0.0

Implements OsiSolverInterface.

virtual const double* OsiXprSolverInterface::getRowLower | ( |  | ) | const
| virtual

Get pointer to array[getNumRows()] of row lower bounds.

Implements OsiSolverInterface.

virtual const double* OsiXprSolverInterface::getRowUpper | ( |  | ) | const
| virtual

Get pointer to array[getNumRows()] of row upper bounds.

Implements OsiSolverInterface.

virtual const double* OsiXprSolverInterface::getObjCoefficients | ( |  | ) | const
| virtual

Get pointer to array[getNumCols()] of objective function coefficients.

Implements OsiSolverInterface.

virtual double OsiXprSolverInterface::getObjSense | ( |  | ) | const
| virtual

Get objective function sense (1 for min (default), -1 for max)

Implements OsiSolverInterface.

virtual bool OsiXprSolverInterface::isContinuous | ( | int | colIndex | ) | const
| virtual

Return true if variable is continuous.

Implements OsiSolverInterface.

virtual const CoinPackedMatrix* OsiXprSolverInterface::getMatrixByRow | ( |  | ) | const
| virtual

Get pointer to row-wise copy of matrix.

Implements OsiSolverInterface.

virtual const CoinPackedMatrix* OsiXprSolverInterface::getMatrixByCol | ( |  | ) | const
| virtual

Get pointer to column-wise copy of matrix.

Implements OsiSolverInterface.

virtual double OsiXprSolverInterface::getInfinity | ( |  | ) | const
| virtual

Get solver's value for infinity.

Implements OsiSolverInterface.

virtual const double* OsiXprSolverInterface::getColSolution | ( |  | ) | const
| virtual

Get pointer to array[getNumCols()] of primal solution vector.

Implements OsiSolverInterface.

virtual const double* OsiXprSolverInterface::getRowPrice | ( |  | ) | const
| virtual

Get pointer to array[getNumRows()] of dual prices.

Implements OsiSolverInterface.

virtual const double* OsiXprSolverInterface::getReducedCost | ( |  | ) | const
| virtual

Get a pointer to array[getNumCols()] of reduced costs.

Implements OsiSolverInterface.

virtual const double* OsiXprSolverInterface::getRowActivity | ( |  | ) | const
| virtual

Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector.

Implements OsiSolverInterface.

virtual double OsiXprSolverInterface::getObjValue | ( |  | ) | const
| virtual

Get objective function value.

Implements OsiSolverInterface.

virtual int OsiXprSolverInterface::getIterationCount | ( |  | ) | const
| virtual

Get how many iterations it took to solve the problem (whatever "iteration" mean to the solver.

Implements OsiSolverInterface.

virtual std::vector< double * > OsiXprSolverInterface::getDualRays | ( | int | maxNumRays,
|  | bool | fullRay = `false`
| ) |  | const
| virtual

Get as many dual rays as the solver can provide.

(In case of proven primal infeasibility there should be at least one.)

The first getNumRows() ray components will always be associated with the row duals (as returned by getRowPrice()). If `fullRay` is true, the final getNumCols() entries will correspond to the ray components associated with the nonbasic variables. If the full ray is requested and the method cannot provide it, it will throw an exception.

NOTE for implementers of solver interfaces:
The double pointers in the vector should point to arrays of length getNumRows() and they should be allocated via new[].

NOTE for users of solver interfaces:
It is the user's responsibility to free the double pointers in the vector using delete[].

Implements OsiSolverInterface.

virtual std::vector< double * > OsiXprSolverInterface::getPrimalRays | ( | int | maxNumRays | ) | const
| virtual

Get as many primal rays as the solver can provide.

(In case of proven dual infeasibility there should be at least one.)

NOTE for implementers of solver interfaces:
The double pointers in the vector should point to arrays of length getNumCols() and they should be allocated via new[].

NOTE for users of solver interfaces:
It is the user's responsibility to free the double pointers in the vector using delete[].

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::setObjCoeff | ( | int | elementIndex,
|  | double | elementValue
| ) |  |
| virtual

Set an objective function coefficient.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::setColLower | ( | int | elementIndex,
|  | double | elementValue
| ) |  |
| virtual

Set a single column lower bound
Use -COIN_DBL_MAX for -infinity.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::setColUpper | ( | int | elementIndex,
|  | double | elementValue
| ) |  |
| virtual

Set a single column upper bound
Use COIN_DBL_MAX for infinity.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::setColBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper
| ) |  |
| virtual

Set a single column lower and upper bound
The default implementation just invokes setColLower() and setColUpper()

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::setColSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList
| ) |  |
| virtual

Set the bounds on a number of columns simultaneously
The default implementation just invokes setColLower() and setColUpper() over and over again.

Parameters

  indexFirst,indexLast | pointers to the beginning and after the end of the array of the indices of the variables whose either bound changes
  boundList | the new lower/upper bound pairs for the variables

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::setRowLower | ( | int | elementIndex,
|  | double | elementValue
| ) |  |
| virtual

Set a single row lower bound
Use -COIN_DBL_MAX for -infinity.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::setRowUpper | ( | int | elementIndex,
|  | double | elementValue
| ) |  |
| virtual

Set a single row upper bound
Use COIN_DBL_MAX for infinity.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::setRowBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper
| ) |  |
| virtual

Set a single row lower and upper bound
The default implementation just invokes setRowLower() and setRowUpper()

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::setRowType | ( | int | index,
|  | char | sense,
|  | double | rightHandSide,
|  | double | range
| ) |  |
| virtual

Set the type of a single row

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::setRowSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList
| ) |  |
| virtual

Set the bounds on a number of rows simultaneously
The default implementation just invokes setRowLower() and setRowUpper() over and over again.

Parameters

  indexFirst,indexLast | pointers to the beginning and after the end of the array of the indices of the constraints whose either bound changes
  boundList | the new lower/upper bound pairs for the constraints

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::setRowSetTypes | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const char * | senseList,
|  | const double * | rhsList,
|  | const double * | rangeList
| ) |  |
| virtual

Set the type of a number of rows simultaneously
The default implementation just invokes setRowType() over and over again.

Parameters

  indexFirst,indexLast | pointers to the beginning and after the end of the array of the indices of the constraints whose any characteristics changes
  senseList | the new senses
  rhsList | the new right hand sides
  rangeList | the new ranges

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::setContinuous | ( | int | index | ) |
| virtual

Set the index-th variable to be a continuous variable.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::setInteger | ( | int | index | ) |
| virtual

Set the index-th variable to be an integer variable.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::setContinuous | ( | const int * | indices,
|  | int | len
| ) |  |
| virtual

Set the variables listed in indices (which is of length len) to be continuous variables.

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::setInteger | ( | const int * | indices,
|  | int | len
| ) |  |
| virtual

Set the variables listed in indices (which is of length len) to be integer variables.

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::setObjSense | ( | double | s | ) |
| virtual

Set objective function sense (1 for min (default), -1 for max,)

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::setColSolution | ( | const double * | colsol | ) |
| virtual

Set the primal solution column values.

colsol[numcols()] is an array of values of the problem column variables. These values are copied to memory owned by the solver object or the solver. They will be returned as the result of colsol() until changed by another call to setColsol() or by a call to any solver routine. Whether the solver makes use of the solution in any way is solver-dependent.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::setRowPrice | ( | const double * | rowprice | ) |
| virtual

Set dual solution vector.

rowprice[numrows()] is an array of values of the problem row dual variables. These values are copied to memory owned by the solver object or the solver. They will be returned as the result of rowprice() until changed by another call to setRowprice() or by a call to any solver routine. Whether the solver makes use of the solution in any way is solver-dependent.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::addCol | ( | const CoinPackedVectorBase & | vec,
|  | const double | collb,
|  | const double | colub,
|  | const double | obj
| ) |  |
| virtual

Add a column (primal variable) to the problem.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::addCols | ( | const int | numcols,
|  | const CoinPackedVectorBase *const * | cols,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj
| ) |  |
| virtual

Add a set of columns (primal variables) to the problem.

The default implementation simply makes repeated calls to addCol().

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::deleteCols | ( | const int | num,
|  | const int * | colIndices
| ) |  |
| virtual

Remove a set of columns (primal variables) from the problem.

The solver interface for a basis-oriented solver will maintain valid warm start information if all deleted variables are nonbasic.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const double | rowlb,
|  | const double | rowub
| ) |  |
| virtual

Add a row (constraint) to the problem.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const char | rowsen,
|  | const double | rowrhs,
|  | const double | rowrng
| ) |  |
| virtual

Add a row (constraint) to the problem.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::addRows | ( | const int | numrows,
|  | const CoinPackedVectorBase *const * | rows,
|  | const double * | rowlb,
|  | const double * | rowub
| ) |  |
| virtual

Add a set of rows (constraints) to the problem.

The default implementation simply makes repeated calls to addRow().

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::addRows | ( | const int | numrows,
|  | const CoinPackedVectorBase *const * | rows,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng
| ) |  |
| virtual

Add a set of rows (constraints) to the problem.

The default implementation simply makes repeated calls to addRow().

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::deleteRows | ( | const int | num,
|  | const int * | rowIndices
| ) |  |
| virtual

Delete a set of rows (constraints) from the problem.

The solver interface for a basis-oriented solver will maintain valid warm start information if all deleted rows are loose.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub
| ) |  |
| virtual

Load in an problem by copying the arguments (the constraints on the rows are given by lower and upper bounds).

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `rowub`: all rows have upper bound infinity
- `rowlb`: all rows have lower bound -infinity
- `obj`: all variables have 0 objective coefficient

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::assignProblem | ( | CoinPackedMatrix *& | matrix,
|  | double *& | collb,
|  | double *& | colub,
|  | double *& | obj,
|  | double *& | rowlb,
|  | double *& | rowub
| ) |  |
| virtual

Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by lower and upper bounds).

For default values see the previous method.
WARNING: The arguments passed to this method will be freed using the C++ `delete` and `delete[]` functions.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng
| ) |  |
| virtual

Load in an problem by copying the arguments (the constraints on the rows are given by sense/rhs/range triplets).

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `obj`: all variables have 0 objective coefficient
- `rowsen`: all rows are >=
- `rowrhs`: all right hand sides are 0
- `rowrng`: 0 for the ranged rows

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::assignProblem | ( | CoinPackedMatrix *& | matrix,
|  | double *& | collb,
|  | double *& | colub,
|  | double *& | obj,
|  | char *& | rowsen,
|  | double *& | rowrhs,
|  | double *& | rowrng
| ) |  |
| virtual

Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by sense/rhs/range triplets).

For default values see the previous method.
WARNING: The arguments passed to this method will be freed using the C++ `delete` and `delete[]` functions.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const int * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub
| ) |  |
| virtual

Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const int * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng
| ) |  |
| virtual

Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).

Implements OsiSolverInterface.

virtual int OsiXprSolverInterface::readMps | ( | const char * | filename,
|  | const char * | extension = `"mps"`
| ) |  |
| virtual

Read an mps file from the given filename.

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::writeMps | ( | const char * | filename,
|  | const char * | extension = `"mps"`,
|  | double | objSense = `0.0`
| ) |  | const
| virtual

Write the problem into an mps file of the given filename.

If objSense is non zero then -1.0 forces the code to write a maximization objective and +1.0 to write a minimization one. If 0.0 then solver can do what it wants

Implements OsiSolverInterface.

void OsiXprSolverInterface::passInMessageHandler | ( | CoinMessageHandler * | handler | ) |
| virtual

Pass in a message handler It is the client's responsibility to destroy a message handler installed by this routine; it will not be destroyed when the solver interface is destroyed.

Reimplemented from OsiSolverInterface.

static void OsiXprSolverInterface::incrementInstanceCounter | ( |  | ) |
| static

XPRESS has a context that must be created prior to all other XPRESS calls.

This method:

- Increments by 1 the number of uses of the XPRESS environment.
- Creates the XPRESS context when the number of uses is changed to 1 from 0.

static void OsiXprSolverInterface::decrementInstanceCounter | ( |  | ) |
| static

XPRESS has a context that should be deleted after XPRESS calls.

This method:

- Decrements by 1 the number of uses of the XPRESS environment.
- Deletes the XPRESS context when the number of uses is change to 0 from 1.

static unsigned int OsiXprSolverInterface::getNumInstances | ( |  | ) |
| static

Return the number of instances of instantiated objects using XPRESS services.

XPRSprob OsiXprSolverInterface::getLpPtr | ( |  | ) |
| inline

Return a pointer to the XPRESS problem.

Definition at line 605 of file OsiXprSolverInterface.hpp.

static int OsiXprSolverInterface::version | ( |  | ) |
| static

Return XPRESS-MP Version number.

static FILE* OsiXprSolverInterface::getLogFilePtr | ( |  | ) |
| static

Get logfile FILE *.

static void OsiXprSolverInterface::setLogFileName | ( | const char * | filename | ) |
| static

Set logfile name.

The logfile is an attempt to capture the calls to Xpress functions for debugging.

virtual OsiSolverInterface* OsiXprSolverInterface::clone | ( | bool | copyData = `true` | ) | const
| virtual

Clone.

Implements OsiSolverInterface.

OsiXprSolverInterface& OsiXprSolverInterface::operator= | ( | const OsiXprSolverInterface & | rhs | ) |

Assignment operator.

virtual void OsiXprSolverInterface::applyRowCut | ( | const OsiRowCut & | rc | ) |
| protected virtual

Apply a row cut. Return true if cut was applied.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::applyColCut | ( | const OsiColCut & | cc | ) |
| protected virtual

Apply a column cut (bound adjustment).

Return true if cut was applied.

Implements OsiSolverInterface.

void OsiXprSolverInterface::gutsOfCopy | ( | const OsiXprSolverInterface & | source | ) |
| private

The real work of a copy constructor (used by copy and assignment)

void OsiXprSolverInterface::gutsOfConstructor | ( |  | ) |
| private

The real work of a constructor (used by construct and assignment)

void OsiXprSolverInterface::gutsOfDestructor | ( |  | ) |
| private

The real work of a destructor (used by copy and assignment)

void OsiXprSolverInterface::freeSolution | ( |  | ) |
| private

Destroy cached copy of solution data (whenever it changes)

void OsiXprSolverInterface::freeCachedResults | ( |  | ) |
| private

Destroy cached copies of problem and solution data (whenever they change)

int OsiXprSolverInterface::getNumIntVars | ( |  | ) | const
| private

Number of integer variables in the problem.

void OsiXprSolverInterface::getVarTypes | ( |  | ) | const
| private

Build cached copy of variable types.

void OsiXprSolverInterface::activateMe | ( |  | ) | const
| private

Save the current problem in XPRESS (if necessary) and make this problem current (restore if necessary).

bool OsiXprSolverInterface::isDataLoaded | ( |  | ) | const
| private

Save and restore are necessary if there is data associated with this problem.

Also, queries to a problem with no data should respond sensibly; XPRESS query results are undefined.

## Friends And Related Function Documentation

void OsiXprSolverInterfaceUnitTest | ( | const std::string & | mpsDir,
|  | const std::string & | netlibDir
| ) |  |
| friend

A function that tests the methods in the OsiXprSolverInterface class.

## Member Data Documentation

int OsiXprSolverInterface::iXprCallCount_
| static

Definition at line 613 of file OsiXprSolverInterface.hpp.

const char* OsiXprSolverInterface::logFileName_
| static private

Name of the logfile.

Definition at line 657 of file OsiXprSolverInterface.hpp.

FILE* OsiXprSolverInterface::logFilePtr_
| static private

The FILE* to the logfile.

Definition at line 660 of file OsiXprSolverInterface.hpp.

unsigned int OsiXprSolverInterface::numInstances_
| static private

Number of live problem instances.

Definition at line 663 of file OsiXprSolverInterface.hpp.

unsigned int OsiXprSolverInterface::osiSerial_
| static private

Counts calls to incrementInstanceCounter()

Definition at line 666 of file OsiXprSolverInterface.hpp.

XPRSprob OsiXprSolverInterface::prob_
| mutable private

Definition at line 715 of file OsiXprSolverInterface.hpp.

std::string OsiXprSolverInterface::xprProbname_
| mutable private

XPRESS problem name (should be unique for each saved problem)

Definition at line 718 of file OsiXprSolverInterface.hpp.

CoinPackedMatrix* OsiXprSolverInterface::matrixByRow_
| mutable private

Pointer to row-wise copy of problem matrix coefficients.

Note that XPRESS keeps the objective row in the problem matrix, so row indices and counts are adjusted accordingly.

Definition at line 728 of file OsiXprSolverInterface.hpp.

CoinPackedMatrix* OsiXprSolverInterface::matrixByCol_
| mutable private

Definition at line 729 of file OsiXprSolverInterface.hpp.

double* OsiXprSolverInterface::colupper_
| mutable private

Pointer to dense vector of structural variable upper bounds.

Definition at line 732 of file OsiXprSolverInterface.hpp.

double* OsiXprSolverInterface::collower_
| mutable private

Pointer to dense vector of structural variable lower bounds.

Definition at line 735 of file OsiXprSolverInterface.hpp.

double* OsiXprSolverInterface::rowupper_
| mutable private

Pointer to dense vector of slack variable upper bounds.

Definition at line 738 of file OsiXprSolverInterface.hpp.

double* OsiXprSolverInterface::rowlower_
| mutable private

Pointer to dense vector of slack variable lower bounds.

Definition at line 741 of file OsiXprSolverInterface.hpp.

char* OsiXprSolverInterface::rowsense_
| mutable private

Pointer to dense vector of row sense indicators.

Definition at line 744 of file OsiXprSolverInterface.hpp.

double* OsiXprSolverInterface::rhs_
| mutable private

Pointer to dense vector of row right-hand side values.

Definition at line 747 of file OsiXprSolverInterface.hpp.

double* OsiXprSolverInterface::rowrange_
| mutable private

Pointer to dense vector of slack upper bounds for range constraints (undefined for non-range rows)

Definition at line 752 of file OsiXprSolverInterface.hpp.

double* OsiXprSolverInterface::objcoeffs_
| mutable private

Pointer to dense vector of objective coefficients.

Definition at line 755 of file OsiXprSolverInterface.hpp.

double OsiXprSolverInterface::objsense_
| mutable private

Sense of objective (1 for min; -1 for max)

Definition at line 758 of file OsiXprSolverInterface.hpp.

double* OsiXprSolverInterface::colsol_
| mutable private

Pointer to dense vector of primal structural variable values.

Definition at line 761 of file OsiXprSolverInterface.hpp.

double* OsiXprSolverInterface::rowsol_
| mutable private

Pointer to dense vector of primal slack variable values.

Definition at line 764 of file OsiXprSolverInterface.hpp.

double* OsiXprSolverInterface::rowact_
| mutable private

Pointer to dense vector of primal slack variable values.

Definition at line 767 of file OsiXprSolverInterface.hpp.

double* OsiXprSolverInterface::rowprice_
| mutable private

Pointer to dense vector of dual row variable values.

Definition at line 770 of file OsiXprSolverInterface.hpp.

double* OsiXprSolverInterface::colprice_
| mutable private

Pointer to dense vector of dual column variable values.

Definition at line 773 of file OsiXprSolverInterface.hpp.

int* OsiXprSolverInterface::ivarind_
| mutable private

Pointer to list of indices of XPRESS "global" variables.

Definition at line 776 of file OsiXprSolverInterface.hpp.

char* OsiXprSolverInterface::ivartype_
| mutable private

Pointer to list of global variable types:

- 'B': binary variable
- 'I': general integer variable (but might have 0-1 bounds)
- 'P': partial integer variable (not currently supported)
- 'S': sem-continuous variable (not currently supported)

Definition at line 786 of file OsiXprSolverInterface.hpp.

char* OsiXprSolverInterface::vartype_
| mutable private

Pointer to dense vector of variable types (as above, or 'C' for continuous)

Definition at line 791 of file OsiXprSolverInterface.hpp.

bool OsiXprSolverInterface::lastsolvewasmip
| mutable private

Indicates whether the last solve was for a MIP or an LP.

Definition at line 794 of file OsiXprSolverInterface.hpp.

bool OsiXprSolverInterface::domipstart
| private

Whether to pass a column solution to XPRESS before starting MIP solve (loadmipsol)

Definition at line 799 of file OsiXprSolverInterface.hpp.

The documentation for this class was generated from the following file:

- /tmp/Cgl-0.60.2/Osi/src/OsiXpr/OsiXprSolverInterface.hpp